package com.villanueva.production.livooks.adapters

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageButton
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.villanueva.production.livooks.R
import com.villanueva.production.livooks.interfaces.ClickListenerQuote

class QuotesRecyclerViewAdapter(private var items:ArrayList<String>,var listener: ClickListenerQuote):
    RecyclerView.Adapter<QuotesRecyclerViewAdapter.ViewHolder>() {

    fun setItems(quoteList: ArrayList<String>) {
        //items?.clear()
        items = quoteList
        notifyDataSetChanged()

    }


    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.template_quoutes_list, parent, false)
        val viewHolder = ViewHolder(view,listener)
        return viewHolder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {

        val item = items[position]
        holder.tvQuote?.text = item

    }

    override fun getItemCount(): Int {
        return items.size
    }




    inner class ViewHolder(view: View, listener: ClickListenerQuote):RecyclerView.ViewHolder(view), View.OnClickListener{
        var tvQuote : TextView? = null
        var ibQuoteList: ImageButton? = null

        var listener : ClickListenerQuote? = null

        init {
            tvQuote = view.findViewById(R.id.tv_quote)
            ibQuoteList = view.findViewById<ImageButton>(R.id.ib_quoteList)

            //Inicializo el listener
            this.listener = listener

            //Cuando llegue al viewHolder se va a activar el listner de cada vista
            ibQuoteList?.setOnClickListener(this)

        }

        override fun onClick(v: View?) {

            listener?.onClickMenu(v!!,adapterPosition)


        }


    }


}