package com.villanueva.production.livooks.adapters

import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.ImageButton
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.squareup.picasso.Picasso
import com.villanueva.production.livooks.R
import com.villanueva.production.livooks.interfaces.ClickListenerSearch
import com.villanueva.production.livooks.model.BookFirebaseModel

class ReadingRecyclerViewAdapter(private var items: ArrayList<BookFirebaseModel>?, var listener: ClickListenerSearch):
    RecyclerView.Adapter<ReadingRecyclerViewAdapter.ViewHolder>() {


    fun setItems(bookList: ArrayList<BookFirebaseModel>) {
        //items?.clear()
        items = bookList
        notifyDataSetChanged()

    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val view = LayoutInflater.from(parent.context)
            .inflate(R.layout.templete_category_booklist, parent, false)
        val viewHolder = ViewHolder(view,listener)
        return viewHolder
    }

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        val booksReading = items?.get(position)
        holder.tvTitleReading?.text = booksReading?.title

        holder.tvAuthorReading?.text = booksReading?.author

        if(booksReading?.image == null){
            Picasso.get().load(R.drawable.cover_not_avalaible).into(holder.ivBooksReading)
        }else{
            Picasso.get()
                .load(booksReading.image)
                .into(holder.ivBooksReading)
        }

    }




    override fun getItemCount(): Int {
        return items?.size!!
    }

    inner class ViewHolder(view: View, listener: ClickListenerSearch):RecyclerView.ViewHolder(view),View.OnClickListener  {

        var tvTitleReading: TextView? = null
        var tvAuthorReading: TextView? = null
        var ivBooksReading: ImageView? = null
        var ibMenuCardView: ImageButton? = null


        //Declaro el clicklistener de nuestra iterface(esto es para el cuando de al botón sobre elemento)
        var listener : ClickListenerSearch? = null

        init {
            tvTitleReading = view.findViewById<TextView>(R.id.tv_titleReading)
            tvAuthorReading = view.findViewById<TextView>(R.id.tv_authorReading)
            ivBooksReading = view.findViewById<ImageView>(R.id.iv_bookReading)
            ibMenuCardView = view.findViewById<ImageButton>(R.id.ib_menuCardview)

            //Inicializo el listener
            this.listener = listener

            //Cuando llegue al viewHolder se va a activar el listner de cada vista
            view.setOnClickListener(this)
            ibMenuCardView?.setOnClickListener(this)

        }

        override fun onClick(v: View?) {
            if(v != ibMenuCardView){
                listener?.onClickSearch(v!!,adapterPosition)
            }else{
                listener?.onClickMenu(v!!,adapterPosition)
            }

        }
    }


}