package com.villanueva.production.livooks.fragments

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import androidx.cardview.widget.CardView
import androidx.fragment.app.Fragment
import com.villanueva.production.livooks.R
import com.villanueva.production.livooks.utils.FirebaseRepo

class MyBooksFragment : Fragment() {

    private val firebaseRepo = FirebaseRepo()

    private lateinit var statusBook: String
    private lateinit var tvNumReading: TextView
    private lateinit var tvNumRead: TextView
    private lateinit var tvNumPending: TextView
    private lateinit var tvNumWished: TextView

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?,
        savedInstanceState: Bundle?
    ): View? {

        val viewMyBooks = inflater.inflate(R.layout.fragment_my_books, container, false)

        //button cardview see books I am reading
        val cvReading = viewMyBooks.findViewById<CardView>(R.id.cv_reading)
        cvReading.setOnClickListener {
            statusBook = "Reading"
            seeBooksCategory(statusBook)
        }

        //button cardview see books I am read
        val cvRead = viewMyBooks.findViewById<CardView>(R.id.cv_read)
        cvRead.setOnClickListener {
            statusBook = "Read"
            seeBooksCategory(statusBook)
        }

        //button cardview see books I have pending
        val cvPending = viewMyBooks.findViewById<CardView>(R.id.cv_pendings)
        cvPending.setOnClickListener {
            statusBook = "Pending"
            seeBooksCategory(statusBook)
        }

        //button cardview see books I have pending
        val cvWished = viewMyBooks.findViewById<CardView>(R.id.cv_whised)
        cvWished.setOnClickListener {
            statusBook = "Wished"
            seeBooksCategory(statusBook)
        }

        //FLOAT ACTION BUTTOM (it will be implemented later)
       /* val fbFloatButton: View = viewMyBooks.findViewById(R.id.fb_floatButtom)
        fbFloatButton.setOnClickListener { view ->
            Snackbar.make(view, "Here's a Snackbar", Snackbar.LENGTH_LONG)
                .setAction("Action", null)
                .show()
        }*/

        //count book in each category
        tvNumReading = viewMyBooks.findViewById(R.id.tv_numReading)
        firebaseRepo.numberBooksCategory("Reading", tvNumReading)
        tvNumRead = viewMyBooks.findViewById(R.id.tv_numRead)
        firebaseRepo.numberBooksCategory("Read", tvNumRead)
        tvNumPending = viewMyBooks.findViewById(R.id.tv_numPending)
        firebaseRepo.numberBooksCategory("Pending", tvNumPending)
        tvNumWished = viewMyBooks.findViewById(R.id.tv_numWished)
        firebaseRepo.numberBooksCategory("Wished", tvNumWished)

        // Inflate the layout for this fragment
        return viewMyBooks
    }

    //Depending category choose go the content of fragment will be different
    fun seeBooksCategory(statusBook: String) {
        val categoryFragment = CategoryFragment()
        val transaction = activity?.supportFragmentManager?.beginTransaction()
        transaction?.replace(R.id.fc_fragmentContainer, categoryFragment,"ok"
        )?.addToBackStack("ok")
        transaction?.commit()

        //pass the data from one fragment to another
        val bundle = Bundle()
        bundle.putString("statusBookKey", statusBook)
        parentFragmentManager.setFragmentResult("statusKey", bundle)

    }


}