package com.villanueva.production.livooks.fragments

import android.content.Intent
import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.Button
import android.widget.ImageView
import android.widget.TextView
import androidx.appcompat.app.AppCompatActivity
import androidx.fragment.app.Fragment
import com.firebase.ui.auth.AuthUI
import com.google.firebase.auth.FirebaseAuth
import com.squareup.picasso.Picasso
import com.villanueva.production.livooks.FirebaseUIActivity
import com.villanueva.production.livooks.R


class ProfileFragment : Fragment() {

    private lateinit var mAuth: FirebaseAuth

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

    }

    override fun onCreateView(
        inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle?
    ): View? {
        // Inflate the layout for this fragment
        val viewProfile = inflater.inflate(R.layout.fragment_profile, container, false)

        //CUSTOM TOOLBAR
        val tbFragmentProfile = viewProfile.findViewById<androidx.appcompat.widget.Toolbar>(R.id.tb_fragmentProfile)
        tbFragmentProfile.inflateMenu(R.menu.menu_profile)

        val actionBar = activity as AppCompatActivity?
        actionBar?.supportActionBar?.hide()
        actionBar?.findViewById<android.widget.SearchView>(R.id.sv_searchview)?.visibility = View.GONE

        tbFragmentProfile.setOnMenuItemClickListener {
            when (it.itemId) {
                R.id.it_profileEdit -> {
                    //implement later
                    true
                }
                else -> {
                    super.onOptionsItemSelected(it)
                }
            }
        }

        mAuth = FirebaseAuth.getInstance()
        val currentUser = mAuth.currentUser

        //Details Profile, user account
        val tvProfileName = viewProfile.findViewById<TextView>(R.id.tv_profileName)
        tvProfileName.text = currentUser?.displayName

        val tvProfileEmail = viewProfile.findViewById<TextView>(R.id.tv_profileEmail)
        tvProfileEmail.text = currentUser?.email

        val ivProfilePhoto = viewProfile.findViewById<ImageView>(R.id.iv_profilePhoto)
        //Glide.with(this).load(currentUser?.photoUrl).into(ivProfilePhoto)
        Picasso.get().load(currentUser?.photoUrl).into(ivProfilePhoto)

        //Logout button
        val btCerrarSesion = viewProfile.findViewById<Button>(R.id.bt_cerrarSesion)
        btCerrarSesion.setOnClickListener {
            // [START auth_fui_signout]
            AuthUI.getInstance()

                .signOut(this.requireContext())
                //.signOut(activity!!.application)
                .addOnCompleteListener {
                    val intent = Intent(activity, FirebaseUIActivity::class.java)
                    startActivity(intent)
                    activity?.finish()
                }
        }
        return viewProfile

    }

}

