package com.villanueva.production.livooks.utils

import android.util.Log
import android.widget.RatingBar
import android.widget.TextView
import com.google.android.gms.tasks.Task
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.firestore.DocumentSnapshot
import com.google.firebase.firestore.FieldValue
import com.google.firebase.firestore.FirebaseFirestore
import com.villanueva.production.livooks.TAG

class FirebaseRepo {

    private val db = FirebaseFirestore.getInstance()
    private var mAuth: FirebaseAuth = FirebaseAuth.getInstance()


    fun numberBooksCategory(statusBook: String, tvNumReading: TextView) {
        db.collection("Users").document(mAuth.currentUser?.email.toString())
            .collection(statusBook).get().addOnSuccessListener {
                when (statusBook) {
                    "Reading" -> tvNumReading.text = "${it.size()} LIBROS"
                    "Read" -> tvNumReading.text = "${it.size()} LIBROS"
                    "Pending" -> tvNumReading.text = "${it.size()} LIBROS"
                    "Wished" -> tvNumReading.text = "${it.size()} LIBROS"
                }

            }
    }

    fun numberQuotes(status:String, title: String?, tvNumQuotes: TextView) {
        val docRef = db.collection("Users").document(mAuth.currentUser?.email.toString())
            .collection(status).document(title!!)
        docRef.get()
           /* .addOnSuccessListener {
                //tvNumQuotes.text =
                //tvNumQuotes.text = listOf(it.get("quotes")).count().toString()
                tvNumQuotes.text = "( ${(it.get("quotes") as ArrayList<String>).size.toString()} Citas )"
            }*/

            .addOnCompleteListener { task: Task<DocumentSnapshot?> ->
                if (task.isSuccessful) {
                    val document = task.result
                    if (document?.get("quotes") != null) {

                        tvNumQuotes.text = "( ${ (document["quotes"] as ArrayList<String>).size} Citas )"
                    }else{
                        tvNumQuotes.text = "( 0 Citas )"
                    }
                   //Log.d(TAG, (document?.get("quotes") as ArrayList<String>).size.toString())

                }
            }

            /*.addOnCompleteListener { task: Task<DocumentSnapshot?> ->
                if (task.isSuccessful) {
                    val document = task.result
                    if (document?.get("quotes")!=null) {
                       (document["quotes"] as ArrayList<String>).size

                    }
                    Log.d(TAG,  (document?.get("quotes") as ArrayList<String>).size.toString())

                }
            }*/

    }



    //Function for add users to firestore database
    fun setUser(userEmail: String){
        val user = hashMapOf(
            "userEmail" to userEmail,
        )
        db.collection("Users").document(userEmail)
            .set(user)
            .addOnSuccessListener {
                Log.d(TAG, "Usiario guardado con email: $userEmail}")
                //Toast.makeText(Activity().applicationContext, "Elemento movido", Toast.LENGTH_SHORT).show()
                //Toast.makeText(FragmentActivity().applicationContext, "Contacts uploaded successfully!", Toast.LENGTH_SHORT).show();
                //Snackbar.make(BookSearchDetailsFragment().context, "pepe", Snackbar.LENGTH_SHORT).show()
            }
            .addOnFailureListener { e -> Log.w(TAG, "Error writing document", e)
            }
    }

    fun setBookData(status:String, title: String?, author: String?, image: String?,
                    startDate:String?, endDate:String?, ratingBook: Float?,
                    quoteListString:ArrayList<String>?) {

        val book = hashMapOf(
            "title" to title,
            "author" to author,
            "image" to image,
            "startDate" to startDate,
            "endDate" to endDate,
            "ratingBook" to ratingBook,
            "quotes" to quoteListString
        )

        db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
            .set(book)
            .addOnSuccessListener {
            }
            .addOnFailureListener {
                    e -> Log.w(TAG, "Error writing document", e)
            }
    }


    fun deleteBook(title: String?, status: String){
        db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
            .delete()
            .addOnSuccessListener {
                Log.d(TAG, "DocumentSnapshot successfully deleted!") }
            .addOnFailureListener {
                    e -> Log.w(TAG, "Error deleting document", e) }
    }


    fun updtateBookDate(status:String, title: String?, date:String) {
        val docRef =  db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
    // Set the "date" field of the book
        docRef.update("startDate", date)
            .addOnSuccessListener { Log.d(TAG, "DocumentSnapshot successfully updated!") }
            .addOnFailureListener { e -> Log.w(TAG, "Error updating document", e) }
    }

    fun updtateBookEndDate(status:String, title: String?, date:String) {
        val docRef =  db.collection("Users").document(mAuth.currentUser?.email.toString())
            .collection(status).document(title!!)
        // Set the "date" field of the book
        docRef.update("endDate", date)
            .addOnSuccessListener { Log.d(TAG, "DocumentSnapshot successfully updated!") }
            .addOnFailureListener { e -> Log.w(TAG, "Error updating document", e) }
    }

    fun getBookStartDate(status:String, title: String?, textView: TextView) {
       val docRef = db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
       docRef.get().addOnSuccessListener { document ->
           if (document != null) {
               val date = document.getString("startDate")
               if (date != null) {
                  textView.text = date
               }
           } else {
               Log.d(TAG, "No such document")
           }
       }
           .addOnFailureListener { exception ->
               Log.d(TAG, "get failed with ", exception)
           }
   }

    fun getBookEndDate(status:String, title: String?,textView: TextView) {
        val docRef = db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
        docRef.get().addOnSuccessListener { document ->
            if (document != null) {
                val date = document.getString("endDate")
                if (date != null) {
                    textView.text = date
                }
            } else {
                Log.d(TAG, "No such document")
            }
        }
            .addOnFailureListener { exception ->
                Log.d(TAG, "get failed with ", exception)
            }
    }

    fun updtateRatingBook(status:String, title: String?, rating:Float?) {
        val docRef =  db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
        // Set the "rating" field of the book
        docRef.update("ratingBook", rating)
            .addOnSuccessListener { Log.d(TAG, "DocumentSnapshot successfully updated!") }
            .addOnFailureListener { e -> Log.w(TAG, "Error updating document", e) }
    }

    fun getRatingBook(status:String, title: String?,ratingBook:RatingBar) {
        val docRef = db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
        docRef.get().addOnSuccessListener { document ->
            if (document != null) {
                val rating = document.getDouble("ratingBook")
                    ratingBook.rating = rating!!.toFloat()

            } else {
                Log.d(TAG, "No such document")
            }
        }
            .addOnFailureListener { exception ->
                Log.d(TAG, "get failed with ", exception)
            }
    }



    fun updtateBookQuotes(status:String, title: String?, quoteNew:String) {
        val docRef =  db.collection("Users").document(mAuth.currentUser?.email.toString())
            .collection(status).document(title!!)
        // Set the "date" field of the book
        docRef.update("quotes", FieldValue.arrayUnion(quoteNew))

            .addOnSuccessListener { Log.d(TAG, "DocumentSnapshot successfully updated!") }
            .addOnFailureListener { e -> Log.w(TAG, "Error updating document", e) }
    }


    fun deleteQuote(quote:String, title: String?, status: String){
        val docRef = db.collection("Users").document(mAuth.currentUser?.email.toString()).collection(status).document(title!!)
        docRef.update("quotes", FieldValue.arrayRemove(quote))
            .addOnSuccessListener {
                Log.d(TAG, "DocumentSnapshot successfully deleted!") }
            .addOnFailureListener {
                    e -> Log.w(TAG, "Error deleting document", e) }
    }



}

